/*************************\
*                         *
*  Implements font cache  *
*                         *
\*************************/

#include <stdlib.h>
#include <string.h>

#include "fontcache.h"
#include "debug.h"


/* Removing callback */
int
RemoveFunc(gpointer key, gpointer value, gpointer user_data)
{
	GdkFont *font=(GdkFont *)value;
	user_data=user_data;

	DTP("RemoveFunc()\n");

	gdk_font_unref(font);
	free(key);
	return(1);
}

/**************/

TCADFontCache::TCADFontCache()
{
	DTP("TCADFontCache::TCADFontCache()\n");

	ht = g_hash_table_new(g_str_hash,g_str_equal);
}

TCADFontCache::~TCADFontCache()
{
	DTP("TCADFontCache::~TCADFontCache()\n");

	g_hash_table_foreach_remove(ht,RemoveFunc,NULL);
}

GdkFont *
TCADFontCache::GetFont(char *FontName)
{
	GdkFont *res = (GdkFont *)g_hash_table_lookup(ht,FontName);
	DTP("TCADFontCache::GetFont()\n");

	if (res) return(res);

	res = gdk_font_load(FontName);
	if (res == NULL) {
		// Try to get "reasonable" font...
		res = gdk_font_load("-*-times-medium-r-normal--12-120-75-75-p-64-iso8859-1");
		if (res == NULL) {
			// Accept anything...
			res = gdk_font_load("-*-*-*-*-*--*-*-*-*-*-*-*-*");
			if (res == NULL) return(NULL);	// ????
		}
	}
	g_hash_table_insert(ht,strdup(FontName),res);

	return(res);
}

