/*******************\
*                   *
*  Text properties  *
*                   *
\*******************/

#ifndef GTKFIG_TEXT_PROPERTIES_H
#define GTKFIG_TEXT_PROPERTIES_H

#include <gdk/gdk.h>
#include "streams.h"
#include "object.h"

/*
 * Alignment types
 */

typedef enum { AL_LEFT, AL_HCENTER, AL_RIGHT /*,  AL_HFULL */ } THAlign;
typedef enum { AL_TOP,  AL_VCENTER, AL_BOTTOM /*, AL_VFULL */ } TVAlign;

/*
 * Defines interface of text properties
 */
class TCADTextPropertiesI {
protected:
	// Indexes to font properties
	enum { FPI_FOUNDRY=1, FPI_FAMILY, FPI_WEIGHT, FPI_SLANT, FPI_SETWIDTH, FPI_ADDSTYLE, FPI_POINTSIZE, FPI_PIXELSIZE, FPI_RESOLUTIONX, FPI_RESOLUTIONY, FPI_AVERAGEWIDTH, FPI_SPACING, FPI_CHARSET, FPI_SUBCHARSET, FPI_NUMBEROF };

	struct FontProperties {
		char *(Prop[FPI_NUMBEROF]);
	};

  GdkColor *TextColor;
  THAlign TextHAlign;
  TVAlign TextVAlign;
	int FNSize;	// Font name buffer size
	char *FontName;	// Includes '%d' on the place where should be size
	char *FontNameBuf;	// Here we will print complete font name
	int FontSize;
  void SaveTextProperties(TCADSaveStream *Fl);
  char LoadProperty(TCADLoadStream *Fl,char *ID);

	void GetFontProperties(FontProperties &fp);

	const char *ConvertFontProperty(const char *Property,char **Table);
public:
  TCADTextPropertiesI();
  ~TCADTextPropertiesI();

  void ShowTextProperties(TCADObject *Obj);

	void DrawText(GdkDrawable &Drawable,GdkGC &GCtx,char *Text,int Lines,GdkRectangle &Rect,int MagA,int MagB);

	void GetFigFont(int &FigFont,int &FigFontStyle);
	void ExportEPSFont(FILE *Fl);
};

#endif

